/*
 * mod_zipvfs: http://modzipvfs.sourceforge.net/
 *
 * Apache2 API compliant module, version 0.1 (24-Jul-2002)
 *
 * Copyright (c) 2002 Pavel Kral, All rights reserved.
 * Distributed under GNU GENERAL PUBLIC LICENCE see copying for more
 *
 * This module represent zip compatabile archive (PkWare,WinZip,Jar) as
 * virtual filesystem, allow traverzal throught and read content. This
 * is especially usefull for large documentations (Java JDK). Support for
 * sending raw data if browser has ability to read gziped content and for
 * normal decompressed content. Support for automatics directory listing
 * and index searching.
 *
 */

#include "httpd.h"
#include "http_protocol.h"
#include "unzip.h"

#include "mod_zipvfs.h"


void sendBeginHtmlData(zipResourceRequest *zipRRequest) {
	ap_rprintf(zipRRequest->request,
		"<html>"
	    "<head>"
	    "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=windows-1250\">"
	    "<title>mod_zipvfs</title>"
		"<style type=\"text/css\">"
		"body { font-family : Arial CE, Arial, Helvetica, sans-serif; font-size : 8pt ; font-weight : normal }"
		"</style>"
	    "</head>"
	    "<body>");
}

void sendEndHtmlData(zipResourceRequest *zipRRequest) {
	ap_rprintf(zipRRequest->request,
		"</body>"
		"</html>");
}

void sendZipInfo(zipResourceRequest *zipRRequest) {

	unz_global_info zipGlobalInfo;
	int retCode;

	zipRRequest->request->content_type = HTTP_HTML_CONTENT;

	sendBeginHtmlData(zipRRequest);

	ap_rprintf(zipRRequest->request,
		"<h2>mod_zipvfs</h2>"
		"<br><font size=\"2\">"
		"<i>Copyright (C) 2002 <a href=\"mailto:p.kral@sh.cvut.cz\">Pavel Kral</a></i>, based on <b>unzip</b> "
		"<i>Copyright (C) 1998-2002 Gilles  Vollant</i> and <b>zlib</b> "
		"<i>Copyright (C) 1995-2002 Jean-loup Gailly and Mark Adler</i>"
		"</font><p>"		
		,zipRRequest->request->filename);

	ap_rprintf(zipRRequest->request,
		"<i>mod_zipvfs version 0.1</i><br>"
		"<i>unzip version 0.18</i><br>"
		"<i>zlib version 1.14</i><p><hr>");

	retCode = unzGetGlobalInfo(zipRRequest->zipFile, &zipGlobalInfo);

	if(retCode == UNZ_OK)
		ap_rprintf(zipRRequest->request, "Total <B>%i</B> entries in zip file.\n", zipGlobalInfo.number_entry); else
		ap_rprintf(zipRRequest->request, "Error in zip file!\n");

	sendEndHtmlData(zipRRequest);
}

void sendErrorMsg(zipResourceRequest *zipRRequest,const char *message) {

	zipRRequest->request->content_type = HTTP_HTML_CONTENT;

	sendBeginHtmlData(zipRRequest);
	ap_rprintf(zipRRequest->request,"<b>mod_zivfs error:</b> %s",message);
	sendEndHtmlData(zipRRequest);
}