/*
 * mod_zipvfs: http://modzipvfs.sourceforge.net/
 *
 * Apache2 API compliant module, version 0.1 (24-Jul-2002)
 *
 * Copyright (c) 2002 Pavel Kral, All rights reserved.
 * Distributed under GNU GENERAL PUBLIC LICENCE see copying for more
 *
 * This module represent zip compatabile archive (PkWare,WinZip,Jar) as
 * virtual filesystem, allow traverzal throught and read content. This
 * is especially usefull for large documentations (Java JDK). Support for
 * sending raw data if browser has ability to read gziped content and for
 * normal decompressed content. Support for automatics directory listing
 * and index searching.
 *
 */


#ifndef MOD_ZIPVFS_H
#define MOD_ZIPVFS_H

//#define ENABLE_CRC_SUPPORT
#define ENABLE_LOG_OUTPUT

#define SEND_BUFFER_SIZE 8192

#define HTTP_ACCEPT_ENCODING "Accept-Encoding"
#define HTTP_CONTENT_ENCODING "Content-Encoding"
#define HTTP_HTML_CONTENT "text/html"
#define HTTP_UNKNOWN_CONTENT "text/plain"
#define HTTP_ENCODE_GZIP1 "gzip"
#define HTTP_ENCODE_GZIP2 "x-gzip"

#define HTTP_INDEX_FILE1 "index.html"
#define HTTP_INDEX_FILE2 "index.htm"

#define CMP_CASE_SENSITIVE 1


#define GZIP_DEFLATE_METHOD 8

#define GZIP_FLAG_FTEXT 1
#define GZIP_FLAG_CRC 2
#define GZIP_FLAG_FEXTRA 4
#define GZIP_FLAG_FNAME 8
#define GZIP_FLAG_FCOMMENT 16

#define ZIP_NORMAL_COMPRESSION 0
#define ZIP_MAX_COMPRESSION 2
#define ZIP_FAST_COMPRESSION 4
#define ZIP_SFAST_COMPRESSION 6

#define ZIP_INTFLAG_ASCII 1

#define XFL_NORMAL_COMPRESSION 0
#define XFL_MAX_COMPRESSION  2
#define XFL_FAST_COMPRESSION 4



#define SEND_DEFLATED_DATA 1

typedef struct {
	request_rec		*request;	
	unzFile			zipFile;
	unz_file_info   currentFileInfo;	
	char            *currentFilePath;
	char			*currentFileName;
	int             flags;
} zipResourceRequest;

#endif /* MOD_ZIPVFS_H */